/** MIT License
* 
* Copyright (c) 2018 Ludovic CLUBER 
* 
* Permission is hereby granted, free of charge, to any person obtaining a copy
* of this software and associated documentation files (the "Software"), to deal
* in the Software without restriction, including without limitation the rights
* to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
* copies of the Software, and to permit persons to whom the Software is
* furnished to do so, subject to the following conditions:
*
* The above copyright notice and this permission notice shall be included in all
* copies or substantial portions of the Software.
*
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
* AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
* OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
* SOFTWARE.
*
* http://csvxjs.lcluber.com
*/

var CSVx=function(e){"use strict";function o(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}var i=[{id:1,name:"info"},{id:2,name:"trace"},{id:3,name:"warn"},{id:4,name:"error"},{id:99,name:"off"}],s=function(){function e(e,t){this.setLevel(e),this.content=t}var t=e.prototype;return t.setLevel=function(e){this.level=this.findLevel(e)},t.getLevelId=function(){return this.level.id},t.display=function(){},t.findLevel=function(e){for(var t=0;t<i.length;t++){var n=i[t];if(n.name===e)return n}return this.level?this.level:i[0]},e}(),a=function(){function r(){}var e,t,n;return r.info=function(e){r.log("info",e)},r.trace=function(e){r.log("trace",e)},r.time=function(e){r.log("time",e)},r.warn=function(e){r.log("warn",e)},r.error=function(e){r.log("error",e)},r.log=function(e,t){r.addMessage(e,t);var n=this.messages[this.nbMessages-1];this._level.id<=n.getLevelId()&&n.display()},r.addMessage=function(e,t){this.messages.push(new s(e,t)),this.nbMessages++},r.findLevel=function(e){for(var t=0;t<i.length;t++){var n=i[t];if(n.name===e)return n}return this._level?this._level:i[0]},e=r,(t=[{key:"level",set:function(e){r._level=r.findLevel(e)},get:function(){return r._level.name}}])&&o(e.prototype,t),n&&o(e,n),r}();a._level=a.findLevel(i[0].name),a.messages=[],a.nbMessages=0,a.target=document.getElementById("Mouette");var c=function(){function e(){}return e.json=function(e){if(!this.string(e))return!1;var t=e.replace(/(\r\n|\n|\r|\t)/gm,"");try{t=JSON.parse(e)}catch(e){return a.error(e),!1}return t},e.function=function(e){return e&&"[object Function]"==={}.toString.call(e)},e.object=function(e){return null!==e&&"object"==typeof e},e.ascii=function(e,t){return(t?/^[\x00-\xFF]*$/:/^[\x00-\x7F]*$/).test(e)},e.integer=function(e){return e===parseInt(e,10)},e.string=function(e){return"string"==typeof e},e}(),u=function(){function e(){}return e.scrollToBottom=function(e){e.scrollTop=e.scrollHeight},e.findById=function(e){return document.getElementById(e)},e.showById=function(e){this.findById(e).style.display="block"},e.hideById=function(e){this.findById(e).style.display="none"},e.showOverflow=function(){document.body.style.overflow="visible"},e.hideOverflow=function(){document.body.style.overflow="hidden"},e.getInputValue=function(e){return this.findById(e).value},e.clearInputValue=function(e){this.findById(e).value=""},e.focusOn=function(e){this.findById(e).focus()},e.addHTMLElement=function(e,t,n){var r=document.createElement(t);return void 0!==n&&Object.keys(n).forEach(function(e){"textContent"===e||"innerHTML"===e?r[e]=n[e]:r.setAttribute(e,n[e])}),e.appendChild(r),r},e}(),t=function(){function e(){}return e.data=function(e,t,n){if(!c.object(t[0])&&!c.json(t[0]))return!1;n&&this.setOptions(n);var r="data:"+this.options.data+";charset="+this.options.charset+",";return this.options.labels&&(r+=this.createLabels(t),a.info("[CSVx] "+e+" labels ready")),r+=this.createTable(t),a.info("[CSVx] "+e+" table ready"),this.download(r,e),!0},e.setOptions=function(e){for(var t in e)e.hasOwnProperty(t)&&this.options.hasOwnProperty(t)&&(this.options[t]=e[t])},e.download=function(e,t){var n=encodeURI(e),r=u.addHTMLElement(document.body,"a",{href:n,download:t+".csv"});r.click(),document.body.removeChild(r),a.info("[CSVx] "+t+" downloading")},e.createTable=function(e){var t="",n=e,r=Array.isArray(n),o=0;for(n=r?n:n[Symbol.iterator]();;){var i;if(r){if(o>=n.length)break;i=n[o++]}else{if((o=n.next()).done)break;i=o.value}var s=i,a=c.json(s)||s;if(!c.object(a))return t;var u="";for(var l in a)a.hasOwnProperty(l)&&(u+=this.createField(a[l]));t+=this.createRow(u)}return t},e.createLabels=function(e){var t=c.json(e[0])||e[0],n="";for(var r in t)t.hasOwnProperty(r)&&(n+=this.createField(r));return this.createRow(n)},e.createRow=function(e){return e+this.options.CRLF},e.createField=function(e){return this.options.quote+e+this.options.quote+this.options.separator},e}();return t.options={data:"text/csv",charset:"utf-8",labels:!0,quote:'"',separator:",",CRLF:"\r\n"},e.Export=t,e}({});